fire_demo:
*********************************************************************************
* Small gfx-routine that simulates fire.
* Made by Allan (maccoder@geocities.com)
* Version 0.2, PPC version
*********************************************************************************
**Set up equates
start_x:	equ		0					*start of fire (x-coord)
start_y:	equ		599					*start of fire (y-coord)
dim_x:		equ		200					*dimension of fire x
dim_y:		equ		100					*dimension y
s_width:	equ		800					*screen width
black:		equ		0					*definition black
red:		equ		255					*definition red
frequency:	equ		6					*frequency of red (lower = higher freq.)
*bss section
bss:			reg		r30
buf1_handle:	rs.w	 1
buf2_handle:	rs.w	1
buf1_pointer:	rs.w	1
buf2_pointer:	rs.w	1
res_clut:		rs.w	1
*********************************************************************************		
		ENTRY
		start_up
		bl		init_mac
		bl		init_graph_lib
		Xcall	HideCursor

		li		r3,dim_x*dim_y
		Xcall	NewHandle
		stw		r3,buf1_handle(`bss)
		mr		r20,r3
		Xcall	HLock
		mr		r3,r20
		lwz		r3,(r3)
		stw		r3,buf1_pointer(`bss)

		li		r3,dim_x*dim_y
		Xcall	NewHandle
		stw		r3,buf2_handle(`bss)
		mr		r20,r3
		Xcall	HLock
		mr		r3,r20
		lwz		r3,(r3)
		stw		r3,buf2_pointer(`bss)

		li		r3,128					*from clut_fade
		bl		load_clut
		stw		r3,res_clut(`bss)

		lwz		r3,res_clut(`bss)
		lwz		r3,(r3)
		bl		do_clut

		li		r3,black
		bl		cls_256

fire_loop:
		bl		set_random
		bl		calc_buffer
		bl		switch_buffer
		bl		draw_screen
		bl		getkey_turbo
		cmpwi	r3,0
		beq		fire_loop
QUIT:	 
		li		r3,black
		bl		cls_256
		lwz		r3,buf1_handle(`bss)
		Xcall	HUnlock
		lwz		r3,buf2_handle(`bss)
		Xcall	HUnlock
		Xcall	ShowCursor
		tidy_up
		blr

****************** Routines ********************
*from CLUT_FADE too
load_clut:
		mflr	r28
		mr		r4,r3
		li		r3,"cl"
		li		r5,16
		slw		r3,r3,r5
		li		r5,"ut"
		or		r3,r3,r5
		Xcall	GetResource
		mtlr	r28
		blr

*ALSO from CLUT_FADE (doesn't seem much left for me to do, eh?)
do_clut:		 
		mflr	r29
		mr		r5,r3
		li		r3,0
		li		r4,255
		Xcall	SetEntries
		mtlr	r29
		blr

*More or less a complete copy of 680x0 set_random ... except it's in PPC, of course
set_random:
		mflr	r29
		lwz		r10,buf1_pointer(`bss)
		clr.l	r3
		li		r9,2*dim_x
rand_loop:
		Xcall	Random
		andi	r3,r3,$f
		cmpwi	r3,frequency
		ble		less
		li		r3,red
		b		do_loop
less:
		li		r3,black
do_loop:
		stb		r3,(r10)
		addi	r10,r10,1
		subi	r9,r9,1
		cmpwi	r9,0
		bne		rand_loop
		mtlr	r29
		blr

*Note that I use 4 pixels to get the average, and thus replacing the division with a shift
*The Bruno Method ;)
calc_buffer:
		mflr	r29
		lwz		r3,buf1_pointer(`bss)
		lwz		r4,buf2_pointer(`bss)
		addi	r3,r3,dim_x-1
		addi	r4,r4,2*dim_x
		clr.l	r12
		li		r9,(dim_y-2)*dim_x
calc_loop:
		clr.l	r11
		clr.l	r12
		lbz		r11,(r3)
		lbz		r12,1(r3)
		add.h	r11,r11,r12
		lbz		r12,2(r3)				*new
		add.h	r11,r11,r12
		clr.l	r12
		lbz		r12,dim_x+1(r3)
		add.h	r11,r11,r12
		li		r13,2
		srw		r11,r11,r13
		cmpwi	r11,0
		beq		insert
		subi	r11,r11,1
insert:
		stb		r11,(r4)
		addi	r3,r3,1
		addi	r4,r4,1
		subi	r9,r9,1
		cmpwi	r9,0
		bne		calc_loop
		mtlr	r29
		blr
		
*Switch between the two buffers
switch_buffer:
		mflr	r29
		lwz		r3,buf1_pointer(`bss)
		lwz		r4,buf2_pointer(`bss)
		stw		r4,buf1_pointer(`bss)
		stw		r3,buf2_pointer(`bss)
		mtlr	r29
		blr

*Again this is pretty much the same as 680x0
*Look at the FPU version to find any real change
draw_screen:
		mflr	r29
		clr.l	r10
		clr.l	r19
		clr.l	r20
		lwz		r10,buf1_pointer(`bss)
		addi	r10,r10,5*dim_x
		addi	r19,r19,start_x
		addi	r20,r20,start_y
		li		r9,(dim_y-5)*dim_x
draw_loop:
		clr.l	r11
		lbz		r12,(r10)
		mr		r11,r12
		li		r15,8
		slw		r12,r12,r15
		add.w	r11,r11,r12
		slw		r12,r12,r15
		add.w	r11,r11,r12
		slw		r12,r12,r15
		add.w	r11,r11,r12
		clr.l	r3
		clr.l	r4
		clr.l	r5
		add.h	r3,r3,r19
		add.h	r4,r4,r20
		add.h	r5,r5,r11
		lwz		r6,y_tab(rtoc)
		slwi	r7,r4,2
		add		r6,r6,r7
		lwz		r6,(r6)
		add		r6,r6,r3
		stw		r5,(r6)
		subi	r6,r6,s_width
		stw		r5,(r6)
		subi	r6,r6,s_width
		stw		r5,(r6)
		subi	r6,r6,s_width
		stw		r5,(r6)
		addi	r10,r10,1
		cmpwi	r19,s_width
		bne		cont_line
		li		r19,0
		subi	r20,r20,4
cont_line:
		addi	r19,r19,4
		subi	r9,r9,1
		cmpwi	r9,0
		bne		draw_loop
		mtlr	r29
		blr

******************************************************************************************

		global	fire_demo
		extern_data	y_tab
		extern	init_graph_lib,init_mac,cls_256,getkey_turbo
